#include <bits/stdc++.h>
using namespace std;
long long n,d[100001]={},c[100001]={},s[100001],j;

int main() 
{
 long long m,k,i,a,b,t;
 cin >> n >> m;
 for(i=1;i<=m;i++)
 {
 cin >> a >> b;
 d[a]=d[a]+1;
 if(m==n && d[a]>1)
 {
 cout << "NO";
 return 0;    
 }
 if(d[a]>(m-n+1))
 {
 cout << "NO";
 return 0;    
 }
 }
 if(m<n)
 {
 cout << "NO";
 }
}
